<script setup lang="ts">
import type { PropType } from 'vue';
import { ref, computed } from 'vue';
import type { BaseQuoteCard } from '~/types/base';
import { ChevronLgRight, ChevronLgLeft } from 'slippers-ui/icons';

const props = defineProps({
  header: {
    type: String,
    default: '',
  },
  cards: {
    type: Array as PropType<BaseQuoteCard[]>,
    required: true,
  },
  containerVariant: {
    type: String,
    default: '',
  },
  config: {
    type: Object as PropType<{
      darkMode: boolean;
      background: 'purple' | 'gradient';
      needsVerticalSpacing: boolean;
    }>,
    required: false,
  },
});

const selectedCardIndex = ref(0);
const animation = ref('fade');

const selectedCard = computed(() => props.cards[selectedCardIndex.value]);

const nextCard = () => {
  if (selectedCardIndex.value + 1 === props.cards.length) {
    selectedCardIndex.value = 0;
  } else {
    selectedCardIndex.value++;
  }
  animation.value = 'fade';
};

const prevCard = () => {
  if (selectedCardIndex.value === 0) {
    selectedCardIndex.value = props.cards.length - 1;
  } else {
    selectedCardIndex.value--;
  }
  animation.value = 'fade-left';
};
</script>

<template>
  <section
    aria-roledescription="carousel"
    aria-label="Customer Quote Carousel"
    class="quote-carousel-container"
    :class="{
      'carousel-purple-background': config?.background === 'purple',
      'carousel-gradient-background': config?.background === 'gradient',
      'dark-mode': config?.darkMode,
      'needs-vertical-spacing': config?.needsVerticalSpacing,
    }"
  >
    <SlpContainer class="quote-carousel-wrapper" :variant="containerVariant">
      <div v-if="header" class="header">
        <SlpTypography variant="heading2-bold" tag="h2">
          <div v-html="$md.render(header)" />
        </SlpTypography>
      </div>
      <div class="controls">
        <div v-if="cards.length > 1" class="arrow-btns">
          <SlpButton class="arrow-btns__btn" variant="icon" aria-label="Previous case study" @click="prevCard">
            <SlpIcon :icon="ChevronLgLeft" color="surface-500" />
          </SlpButton>
          <SlpButton class="arrow-btns__btn" variant="icon" aria-label="Next case study" @click="nextCard">
            <SlpIcon :icon="ChevronLgRight" color="surface-500" />
          </SlpButton>
        </div>
      </div>
      <transition :name="animation" mode="out-in">
        <div :key="selectedCard.quote" class="quote-carousel">
          <div class="logo">
            <img
              class="logo__img"
              :src="selectedCard.config.logo"
              :alt="`${selectedCard.author.company} logo`"
              loading="lazy"
            />
          </div>
          <div class="content">
            <SlpColumn :cols="selectedCard.metrics ? 8 : 12" class="quote-container">
              <SlpTypography v-if="selectedCard.headline" tag="p" class="headline" variant="heading5-bold">
                {{ selectedCard.headline }}
              </SlpTypography>
              <SlpTypography class="quote"> "{{ selectedCard.quote }}" </SlpTypography>
              <div v-if="selectedCard.metrics" class="metrics mobile">
                <div v-for="metric in selectedCard.metrics" :key="metric.text" class="metric">
                  <SlpTypography variant="heading5-bold" tag="div" class="number">
                    {{ metric.number }}
                  </SlpTypography>
                  <SlpTypography variant="body3" tag="div" class="text">
                    {{ metric.text }}
                  </SlpTypography>
                </div>
              </div>
              <div v-if="selectedCard.author" class="author">
                <img
                  v-if="selectedCard.config.headshot"
                  class="headshot"
                  :src="selectedCard.config.headshot"
                  alt=""
                  loading="lazy"
                />
                <div class="information">
                  <SlpTypography variant="body2-bold" tag="p" class="name">
                    {{ selectedCard.author.name }}
                  </SlpTypography>
                  <SlpTypography v-if="selectedCard.author.title" variant="body2" tag="p" class="title">
                    {{ selectedCard.author.title }},
                    <span v-if="selectedCard.author.company"> {{ selectedCard.author.company }} </span>
                  </SlpTypography>
                  <SlpTypography v-else variant="body2" tag="p" class="title">{{
                    selectedCard.author.company
                  }}</SlpTypography>
                </div>
              </div>
              <div v-if="selectedCard.cta" class="cta">
                <SlpButton
                  class="button"
                  variant="tertiary"
                  :href="selectedCard.cta.config.href"
                  :data-ga-name="selectedCard.cta.config.dataGaName"
                  :data-ga-location="selectedCard.cta.config.dataGaLocation || 'body'"
                >
                  {{ selectedCard.cta.text || 'View case study' }}
                  <SlpIcon :icon="ChevronLgRight" color="text-200" />
                </SlpButton>
              </div>
            </SlpColumn>
            <SlpColumn v-if="selectedCard.metrics" :cols="4" class="metrics desktop">
              <div v-for="metric in selectedCard.metrics" :key="metric.text" class="metric">
                <SlpTypography variant="heading5-bold" tag="div" class="number">
                  {{ metric.number }}
                </SlpTypography>
                <SlpTypography variant="body3" tag="div" class="text">
                  {{ metric.text }}
                </SlpTypography>
              </div>
            </SlpColumn>
          </div>
        </div>
      </transition>
    </SlpContainer>
  </section>
</template>

<style lang="scss" scoped>
.quote-carousel-container {
  padding-top: $spacing-64;
  padding-bottom: $spacing-96;
}
.carousel-purple-background {
  background-color: $color-surface-800;
  margin: 0 !important;

  @media (max-width: $breakpoint-md) {
    padding-top: 0;
    padding-bottom: 0;
  }
  .quote-carousel-wrapper {
    @media (max-width: $breakpoint-lg) {
      padding-top: 32px;
      padding-bottom: 32px;
    }
  }
}

.carousel-gradient-background {
  background: linear-gradient(90deg, #eee7fd 2.53%, rgba(246, 243, 254, 0.83) 50.98%, rgba(255, 212, 216, 0.45) 100%);
  margin: 0 !important;

  @media (max-width: $breakpoint-md) {
    padding-top: 0;
    padding-bottom: 0;
  }
  .quote-carousel-wrapper {
    @media (max-width: $breakpoint-lg) {
      padding-top: 32px;
      padding-bottom: 32px;
    }
  }
}

.quote-carousel-wrapper {
  display: flex;
  flex-direction: column;
  position: relative;
  overflow-x: hidden;

  @media (max-width: $breakpoint-lg) {
    padding-top: 32px;
    padding-bottom: 32px;
  }
  &.carousel-purple-background {
    &::after {
      content: '';
      position: absolute;
      width: 200vw;
      height: 100%;
      top: 0;
      left: -50vw;
      z-index: -1;
      background: $color-surface-800;
    }
  }
  &.dark-mode {
    &::after {
      content: '';
      position: absolute;
      width: 200vw;
      height: 100%;
      top: 0;
      left: -50vw;
      z-index: -1;
      background: $color-surface-700;
    }
  }

  .controls {
    .arrow-btns {
      margin-top: 24px;
      display: flex;
      gap: 16px;
      align-items: flex-end;
      margin-left: auto;
      justify-content: flex-end;

      @media (min-width: $breakpoint-lg) {
        margin-top: $spacing-32;
      }
      &__btn {
        justify-content: center;
        border-radius: 120px;
        border: 1px solid $color-surface-900;
        padding: $spacing-8;
        height: 40px;
        width: 40px;

        :deep(.slp-icon) {
          transform: none !important;
        }

        &:hover {
          background-color: $color-surface-950;
          color: black;
        }
      }
    }
  }

  .quote-carousel {
    display: flex;
    flex-direction: column;
    gap: $spacing-16;

    .logo {
      &__img {
        max-width: 140px;
        max-height: 45px;
      }
    }
    .content {
      display: flex;
      gap: 64px;
      flex-direction: column;
      @media (min-width: $breakpoint-lg) {
        flex-direction: row;
      }
      .quote-container {
        display: flex;
        flex-direction: column;
        gap: $spacing-24;
        .quote {
          color: $color-text-300;
          font-style: italic;
        }
        .author {
          display: flex;
          flex-direction: row;
          gap: $spacing-16;
          align-items: center;
          img {
            border-radius: 4px 4px 22px 4px;
            width: 70px;
            height: 70px;
            object-fit: cover;
          }
          .information {
            display: flex;
            flex-direction: column;
            gap: $spacing-4;
            justify-content: center;
          }
        }
      }
      .metrics {
        display: flex;
        flex-direction: row;
        &.mobile {
          display: none;
        }
        @media (max-width: $breakpoint-lg) {
          &.mobile {
            display: block;
          }
          &.desktop {
            display: none;
          }
        }
        @media (min-width: $breakpoint-lg) {
          flex-direction: column;
          max-width: 25%;
          min-width: 25%;
        }
        .metric {
          display: flex;
          padding: $spacing-24 0px;
          flex-direction: column;
          justify-content: center;
          align-items: flex-start;
          align-self: stretch;
          border-bottom: 0.5px solid $color-surface-400;

          &:first-child {
            @media (min-width: $breakpoint-lg) {
              border-top: 0.5px solid $color-surface-400;
            }
            @media (max-width: $breakpoint-lg) {
              padding-left: 0;
              & + .metric {
                border-left: 0.5px solid $color-surface-400;
              }
            }
          }
          @media (max-width: $breakpoint-lg) {
            justify-content: center;
            border: none;
            padding: $spacing-16;
            float: left;
          }
        }
      }
    }
  }
}

.needs-vertical-spacing {
  padding: $spacing-64 0;
  @media (min-width: $breakpoint-md) {
    padding: 120px 0;
  }
}

.dark-mode {
  background: $color-surface-700;
  .quote-carousel-wrapper {
    @media (max-width: $breakpoint-lg) {
      padding-top: 32px;
      padding-bottom: 32px;
    }
  }
  .header,
  .headline,
  .quote,
  .author .name,
  .author .title,
  .metric {
    color: $color-text-50 !important;
  }

  .arrow-btns {
    &__btn {
      color: white;
      &:deep(svg) {
        color: #fff;
      }
    }
  }
  .cta {
    .button {
      color: $color-text-50;
      svg {
        color: #fff;
        fill: #fff !important;
      }
    }
  }
}
</style>
